/***********************************************************************
 * Copyright (c) 2005 Jan Demter                                   *
 *                                                                     *
 * This program is free software; you can redistribute it and/or       *
 * modify it under the terms of the GNU General Public License         *
 * as published by the Free Software Foundation; either version 2      *
 * of the License, or (at your option) any later version.              *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,              *
 * MA  02111-1307, USA.                                                *
 *                                                                     *
 * ------------------------------------------------------------------- *
 * project : GONE NSLP                                               *
 * author  : Jan Demter <demter@math.uni-goettingen.de>           * 
 ***********************************************************************/

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/poll.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <err.h>

#include "GONE.h"
#include "GONEClient.h"

int main(int argc, char * argv[])
{
	GONEClient client;
	client.connectToDaemon();
	//client.sendCommand(GONE_CLIENT_SENDMESSAGE);
	//char * satz = "Wasch mich, aber mach mich nicht nass.";
	//client.sendData(inet_addr("192.168.2.11"),
			//		   satz, strlen(satz)+1);
		//client.sendCommand(GONE_CLIENT_SENDMESSAGE, "./text.txt");
	unsigned int counter = 0;
	unsigned int max = 0;

	if(argc > 3)
		max = strtol(argv[3],NULL,10);

	if(argc > 2){
		int file = open(argv[1], O_RDONLY);
		if(file < 0){
			err(1,"open(): %s, %i", __FILE__, __LINE__);
		}
		int read_data = 0;
		char * buffer = (char *)malloc(1024);
		while( 0 < (read_data = read(file, buffer, 1024)) ){
			
			//verbose if more than three arguments
			if(argc > 5)
				std::cerr<< "Sending " << read_data << " bytes\n";
			
			client.sendData(inet_addr(argv[2]), buffer, read_data);

			counter += read_data;
			if(max != 0 && counter >= max)
				break;
			
			if(argc > 4)
				usleep(strtol(argv[4],NULL,10));				
			
		}
		client.sendFin(inet_addr(argv[2]));
		std::cout<<"Sent " << counter << " bytes.\n";
		close(file);
	}
	else{
		std::cerr<<"Usage: "<< argv[0] << " file IPv4-address [delay]\n";
		return 15;
	}
		return 0;
}
