/***********************************************************************
 * Copyright (c) 2005 Henning Peters, Christian Dickmann               *
 *                                                                     *
 * This program is free software; you can redistribute it and/or       *
 * modify it under the terms of the GNU General Public License         *
 * as published by the Free Software Foundation; either version 2      *
 * of the License, or (at your option) any later version.              *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,              *
 * MA  02111-1307, USA.                                                *
 *                                                                     *
 * ------------------------------------------------------------------- *
 * project:  NSIS-Project                                              *
 * author :  Henning Peters <hpeters@math.uni-goettingen.de>           * 
 * author :  Christian Dickmann  <nsis@christian-dickmann.de>          *
 ***********************************************************************/

#include "GenericObject.h"

GenericObject::GenericObject()
{
	count++;

	buffer = NULL;
	tail = NULL;
	mymemory = true;
}

GenericObject::~GenericObject()
{
	count--;

	if (mymemory) {
		//free(buffer);
	}
}

unsigned char * GenericObject::getBuffer()
{
	return buffer;
}

unsigned int GenericObject::getLength()
{
	return tail - buffer;
}

void GenericObject::setBuffer(unsigned char * buffer, unsigned int length)
{
	mymemory = false;
	this->buffer = buffer;
	tail = buffer;
	analyze(buffer, length);
}

void GenericObject::extendBuffer(unsigned int bytes)
{
	if (!mymemory) return;	

	unsigned int length = getLength();
	int oldBufferLength = ((length) >> 6);
	int newBufferLength = ((length + bytes) >> 6);

	if (length > 0 && newBufferLength == oldBufferLength) {
		return;
	}

	unsigned char * newBuffer = (unsigned char*)realloc(buffer, (newBufferLength + 1) << 6);
	memset(newBuffer + length, 0, bytes);

	buffer = newBuffer;
	tail = newBuffer + length;
}

int GenericObject::count = 0;
