/***********************************************************************
 * Copyright (c) 2005 Jan Demter                                       *
 *                                                                     *
 * This program is free software; you can redistribute it and/or       *
 * modify it under the terms of the GNU General Public License         *
 * as published by the Free Software Foundation; either version 2      *
 * of the License, or (at your option) any later version.              *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,              *
 * MA  02111-1307, USA.                                                *
 *                                                                     *
 * ------------------------------------------------------------------- *
 * project : GONE NSLP                                                 *
 * author  : Jan Demter <demter@math.uni-goettingen.de>                * 
 ***********************************************************************/

#ifndef _GENERIC_OBJECT_H_
#define _GENERIC_OBJECT_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>

class GenericObject
{
public:
	GenericObject();
	virtual ~GenericObject();

	virtual void analyze(unsigned char * buffer, unsigned int length) = 0;
	virtual unsigned char * getBuffer();
	virtual void setBuffer(unsigned char * buffer, unsigned int length);
	virtual unsigned int getLength();
	virtual void extendBuffer(unsigned int bytes);

	static int count;

protected:
	unsigned char * buffer;
	unsigned char * tail;
	bool mymemory;
};

#endif // _GENERIC_OBJECT_H_
