/***********************************************************************
 * Copyright (c) 2005 Henning Peters                                   *
 *                                                                     *
 * This program is free software; you can redistribute it and/or       *
 * modify it under the terms of the GNU General Public License         *
 * as published by the Free Software Foundation; either version 2      *
 * of the License, or (at your option) any later version.              *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,              *
 * MA  02111-1307, USA.                                                *
 *                                                                     *
 * ------------------------------------------------------------------- *
 * project : NAT/FW NSLP                                               *
 * author  : Henning Peters <hpeters@math.uni-goettingen.de>           * 
 ***********************************************************************/

#include "GONEHeader.h"

GONEHeader::GONEHeader(unsigned int type, unsigned int length, unsigned int address, unsigned int captokenlist)
{
	extendBuffer(16);
	analyze(tail, 16);
	this->type(type);
	this->length(length);
	this->address(address);
	this->captokenlist(captokenlist);
}

GONEHeader::GONEHeader(unsigned char * buffer, unsigned int length)
{
	setBuffer(buffer, length);
}

void GONEHeader::analyze(unsigned char * buffer, unsigned int length)
{
	tail = buffer;
	typePtr = tail;
	tail += 4;
	lengthPtr = tail;
	tail += 4;
	addressPtr = tail;
	tail += 4;
	captokenlistPtr = tail;
	tail = buffer + length;
}

unsigned int GONEHeader::type()
{
	unsigned int tmp;
	memcpy(&tmp, typePtr, 4);
	return ntohl(tmp);
}

void GONEHeader::type(unsigned int type)
{
	type = htonl(type);
	memcpy(typePtr, &type, 4);
}

unsigned int GONEHeader::length()
{
	unsigned int tmp;
	memcpy(&tmp, lengthPtr, 4);
	return ntohl(tmp);
}

void GONEHeader::length(unsigned int length)
{
	length = htonl(length);
	memcpy(lengthPtr, &length, 4);
}

unsigned int GONEHeader::address()
{
	unsigned int tmp;
	memcpy(&tmp, addressPtr, 4);
	return ntohl(tmp);
}

void GONEHeader::address(unsigned int address)
{
	address = htonl(address);
	memcpy(addressPtr, &address, 4);
}

unsigned int GONEHeader::captokenlist()
{
	unsigned int tmp;
	memcpy(&tmp, captokenlistPtr, 4);
	return ntohl(tmp);
}

void GONEHeader::captokenlist(unsigned int captokenlist)
{
	captokenlist = htonl(captokenlist);
	memcpy(captokenlistPtr, &captokenlist, 4);
}

