/***********************************************************************
 * Copyright (c) 2005 Henning Peters                                   *
 *                                                                     *
 * This program is free software; you can redistribute it and/or       *
 * modify it under the terms of the GNU General Public License         *
 * as published by the Free Software Foundation; either version 2      *
 * of the License, or (at your option) any later version.              *
 *                                                                     *
 * This program is distributed in the hope that it will be useful,     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of      *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *
 * GNU General Public License for more details.                        *
 *                                                                     *
 * You should have received a copy of the GNU General Public License   *
 * along with this program; if not, write to the Free Software         *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,              *
 * MA  02111-1307, USA.                                                *
 *                                                                     *
 * ------------------------------------------------------------------- *
 * project : NAT/FW NSLP                                               *
 * author  : Henning Peters <hpeters@math.uni-goettingen.de>           * 
 ***********************************************************************/

#ifndef _GONEHEADER_H_
#define _GONEHEADER_H_

#include "GenericObject.h"

class GONEHeader : public GenericObject
{
public:
	GONEHeader() {}
	GONEHeader(unsigned int type, unsigned int length, unsigned int address, unsigned int captokenlist);
	GONEHeader(unsigned char * buffer, unsigned int length);
	virtual ~GONEHeader() {}

	virtual void analyze(unsigned char * buffer, unsigned int length);

	unsigned int type();
	void type(unsigned int type);
	unsigned int length();
	void length(unsigned int length);
	unsigned int address();
	void address(unsigned int address);
	unsigned int captokenlist();
	void captokenlist(unsigned int captokenlist);

private:
	unsigned char * typePtr;
	unsigned char * lengthPtr;
	unsigned char * addressPtr;
	unsigned char * captokenlistPtr;
};

#endif // _GONEHEADER_H_
